/**
 * JPaaS
 * Copyright 2012 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * --------------------------------------------------------------------------
 * $Id: $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.jpaas.thresholddetector.core.actuator;

import java.util.List;

import org.osgi.framework.BundleContext;
import org.ow2.jonas.jpaas.thresholddetector.core.ThresholdDetector;
import org.ow2.jonas.jpaas.thresholddetector.core.context.NodeContext;
import org.ow2.util.log.Log;
import org.ow2.util.log.LogFactory;


/**
 * Actuator in the rules
 *
 * @author pelletib
 */
public class Actuator {

    /**
     * Logger
     */
    private static Log logger = LogFactory.getLog(Actuator.class);

    public Actuator() {
    }

    public void init(BundleContext bundleContext) {
    }

 

    /**
     * Dump SR for debug purposes
     */
    public void dumpSRContext() {

        List<NodeContext> nodes = ThresholdDetector.getThresholdDetector().getSystemRepresentation().getNodeContextList();
        for (NodeContext node:nodes) {
            logger.info("DUMP SR - {0}", node);
        }
        logger.info("DUMP SR - {0}", ThresholdDetector.getThresholdDetector().getSystemRepresentation().getGlobalContext());

    }

    /**
     * Dump SR for debug purposes
     */
    public void dumpSRConfiguration() {

        logger.info("DUMP SR - {0}", ThresholdDetector.getThresholdDetector().getSystemRepresentation().getGlobalConfiguration());
    }

    /**
     * Logger
     */
    public void log(String msg) {
    	logger.info("[RULES] {0}", msg);
    }

}
