/**
 * JPaaS
 * Copyright 2012 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * --------------------------------------------------------------------------
 * $Id: $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.jpaas.thresholddetector.core.context;

import java.io.Serializable;

/**
 * Scaler notification
 *
 * @author pelletib
 */
public class ThresholdDetectorNotification implements Serializable {

    /**
     * default serial version UID
     */
    private static final long serialVersionUID = 1L;

    /**
     * Message
     */
	private String msg;

	/**
     * Level
     */
	private String level;

	/**
     * Rule
     */
	private String rule;

    /**
     * Constructors
     *
     */
    public ThresholdDetectorNotification() {
    }

    // Getters and setters
	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public String getLevel() {
		return level;
	}

	public void setLevel(String level) {
		this.level = level;
	}

	public String getRule() {
		return rule;
	}

	public void setRule(String rule) {
		this.rule = rule;
	}

	public String toString() {
		String ret = "";
		ret += "ThresholdDetectorNotification [" + msg + ", " + rule + ", " + level + "]";

		return ret;
	}
}
