/**
 * JPaaS
 * Copyright 2012 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * --------------------------------------------------------------------------
 * $Id: $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.jpaas.thresholddetector.core.drools;

import org.drools.runtime.rule.FactHandle;
import org.ow2.jasmine.rules.api.IDroolsWorkingMemory;
import org.ow2.util.log.Log;
import org.ow2.util.log.LogFactory;

public class ThresholdDetectorWorkingMemory {

	/**
	 * Logger
	 */
	private static Log logger = LogFactory.getLog(ThresholdDetectorWorkingMemory.class);


	public static String WORKING_MEMORY_NAME = "thresholddetector" ;

	/**
	 * Working memory pool of the rules engine
	 */
	private IDroolsWorkingMemoryPoolProxy workingMemoryPoolProxy;

	/**
	 * Working memory pool of the rules engine
	 */
	private IDroolsWorkingMemory workingMemory;


	public ThresholdDetectorWorkingMemory() {


	}

	/**
	 * Init
	 */
	public void init() {
		// Create WM
		try {
			workingMemory = workingMemoryPoolProxy
					.getOrCreate(WORKING_MEMORY_NAME);
			logger.info("get working memory : {0} -> {1}", WORKING_MEMORY_NAME,
					workingMemory);

		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}

	/**
	 * Insert object into WM
	 */
	public FactHandle insert(Object o) {
		FactHandle fact = workingMemory.insert(o);
		logger.info("Insert in working memory <" +
				     WORKING_MEMORY_NAME + "> : {0}",
				     fact);

		return workingMemory.insert(o);
	}
	/**
	 *
	 * @return Drools WM pool service proxy
	 */
	public IDroolsWorkingMemoryPoolProxy getWorkingMemoryPoolProxy() {
		return workingMemoryPoolProxy;
	}


	/**
	 * Set the Drools WM service proxy
	 *
	 * @param workingMemoryPoolProxy
	 */
	public void setWorkingMemoryPoolProxy(
			IDroolsWorkingMemoryPoolProxy workingMemoryPoolProxy) {
		this.workingMemoryPoolProxy = workingMemoryPoolProxy;
	}

	/**
	 * @return working memory ref
	 */
	public IDroolsWorkingMemory getWorkingMemory() {
		return workingMemory;
	}

	/**
	 * Set the working memory reference
	 *
	 * @param workingMemory
	 */
	public void setWorkingMemory(IDroolsWorkingMemory workingMemory) {
		this.workingMemory = workingMemory;
	}
}
