/**
 * JPaaS
 * Copyright 2012 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * --------------------------------------------------------------------------
 * $Id: $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.jpaas.thresholddetector.core.sr;

/**
 * @author pelletib
 *
 */
public interface SystemRepresentationMBean {
	/**
	 * @return the number of awake nodes
	 */
	int getStartedNodeCounter();

	/**
	 * @return number of node in the 'STARTING' state
	 */
	int getStartingNodeCounter();

	/**
	 * @return the number of nodes in cluster
	 */
	int getJoinedNodeCounter();

	/**
	 * @return the number of nodes in error
	 */
	int getErrorNodeCounter();

	/**
	 * @return number of node in the 'FREE' state
	 */
	int getFreeNodeCounter();

	/**
	 * @return number of node in the 'NOTAVAILABLE' state
	 */
	int getNotAvailableNodeCounter();

	/**
	 * @return number of node in the 'CREATED' state
	 */
	int getCreatedNodeCounter();

	/**
	 * @return number of node in the 'CREATING' state
	 */
	int getCreatingNodeCounter();

	/**
	 * @return number of node in the 'STOPPED' state
	 */
	int getStoppedNodeCounter();

	/**
	 * @return Average request rate per node
	 */
	Double getNodeRequestRate();

	/**
	 * @return total request rate per node
	 */
	Double getTotalRequestRate();

}
