export JPHOST="10.197.180.20:19000";
export TMPDIR="/tmp";
export TARGET=""
export HOST=""
export DEBUG=false;

mycurlPOST1()
{
	if [[ $DEBUG = true ]]
	then
		echo "curl POST " $*;
	else
		curl -X POST $1;
	fi
}

mycurlPOST2()
{
	if [[ $DEBUG = true ]]
	then
		echo "curl POST " $*;
	else
		curl -X POST -H "Content-Type: application/xml" --data-binary @$1 $2;
	fi
}

usage(){
  echo "Usage : $0 -t <target-name> -h <target-ip-address> -d";
  exit 1;
}

# Read inputs
if [[ $# -ne 0 ]]; then
  # linux/bash help way
  [[ "$1" = --help ]] && usage
  while getopts ?t:h:d c
  do
    case $c in
      # Nodes
      t)
        TARGET=$OPTARG
        ;;
      h)
        HOST=$OPTARG
        ;;
      d)
        DEBUG=true
        ;;
      *)
        usage
        ;;
    esac
  done
fi


if [[ -z $TARGET || -z $HOST ]]; then
	usage
fi


# create target
sed -e "s/%TARGET%/$TARGET/g" -e "s/%HOST%/$HOST/g" ./create-target.xml > $TMPDIR/create-target.xml.$$
mycurlPOST2 $TMPDIR/create-target.xml.$$ http://$JPHOST/jprobe/target

# create indicators for servlet request rate
mycurlPOST2 ./create-indicator-servletRequestCount.xml http://$JPHOST/jprobe/indicator

mycurlPOST2 ./create-indicator-servletRequestRate.xml http://$JPHOST/jprobe/indicator

# create probe for servlet request rate

sed -e "s/%TARGET%/$TARGET/g" -e "s/%PROBEID%/$TARGET-servlet/g" ./create-probe-servlet.xml > $TMPDIR/create-probe-servlet.xml.$$
mycurlPOST2 $TMPDIR/create-probe-servlet.xml.$$ http://$JPHOST/jprobe/probe

mycurlPOST1 http://$JPHOST/jprobe/probe/$TARGET-servlet/action/start


# create indicator for cputime

mycurlPOST2 ./create-indicator-cputime.xml http://$JPHOST/jprobe/indicator

# create probe for cputime

sed -e "s/%TARGET%/$TARGET/g" -e "s/%PROBEID%/$TARGET-cputime/g" ./create-probe-cputime.xml > $TMPDIR/create-probe-cputime.xml.$$
mycurlPOST2 $TMPDIR/create-probe-cputime.xml.$$ http://$JPHOST/jprobe/probe

mycurlPOST1 http://$JPHOST/jprobe/probe/$TARGET-cputime/action/start


